import { Template } from './Template';
declare const frameworkSpecificTemplates: {
    react: Record<string, Template<any>>;
    'vue@2': Record<string, Template<any>>;
    'vue@3': Record<string, Template<any>>;
};
export declare function guessTemplate<T>(framework: keyof typeof frameworkSpecificTemplates, cwd: string): Promise<{
    defaultTemplate: Template<T>;
    defaultTemplateName: string;
    templatePayload: NonNullable<T> | null;
    possibleTemplates: {
        [x: string]: Template<any>;
    };
} | {
    templatePayload: null;
    defaultTemplate: null;
    defaultTemplateName: null;
    possibleTemplates: {
        [x: string]: Template<any>;
    };
}>;
export {};
