"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.guessTemplate = void 0;
const react_1 = require("./react");
const vue_1 = require("./vue");
const _shared_1 = require("./_shared");
const frameworkSpecificTemplates = {
    react: react_1.reactTemplates,
    'vue@2': vue_1.vueTemplates,
    'vue@3': vue_1.vueTemplates,
};
async function guessTemplate(framework, cwd) {
    const templates = { ..._shared_1.frameworkAgnosticTemplates, ...frameworkSpecificTemplates[framework] };
    for (const [name, template] of Object.entries(templates)) {
        const typedTemplate = template;
        const { success, payload } = typedTemplate.test(cwd);
        if (success) {
            return {
                defaultTemplate: typedTemplate,
                defaultTemplateName: name,
                templatePayload: payload !== null && payload !== void 0 ? payload : null,
                possibleTemplates: templates,
            };
        }
    }
    return {
        templatePayload: null,
        defaultTemplate: null,
        defaultTemplateName: null,
        possibleTemplates: templates,
    };
}
exports.guessTemplate = guessTemplate;
