"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BabelTemplate = void 0;
const chalk_1 = __importDefault(require("chalk"));
const find_up_1 = __importDefault(require("find-up"));
const babel = __importStar(require("@babel/core"));
const findPackageJson_1 = require("../../../findPackageJson");
exports.BabelTemplate = {
    message: `It looks like you have babel config defined. We can use it to transpile your components for testing.\n ${chalk_1.default.red('>>')} This is not a replacement for bundling tool. We will use ${chalk_1.default.red('webpack')} to bundle the components for testing.`,
    recommendedComponentFolder: 'cypress/component',
    dependencies: ['webpack', '@cypress/webpack-dev-server'],
    getExampleUrl: () => 'https://github.com/cypress-io/cypress/tree/develop/npm/react/examples/babel',
    getPluginsCodeAst: () => {
        return {
            requiresReturnConfig: true,
            RequireAst: babel.template.ast('const injectDevServer = require(\'@cypress/react/plugins/babel\')'),
            IfComponentTestingPluginsAst: babel.template.ast([
                'injectDevServer(on, config)',
            ].join('\n'), { preserveComments: true }),
        };
    },
    test: (cwd) => {
        const babelConfig = find_up_1.default.sync(['babel.config.js', 'babel.config.json', '.babelrc', '.babelrc.json'], { type: 'file', cwd });
        if (babelConfig) {
            return { success: true };
        }
        // babel config can also be declared in package.json with `babel` key https://babeljs.io/docs/en/configuration#packagejson
        const packageJsonIterator = findPackageJson_1.createFindPackageJsonIterator(cwd);
        return packageJsonIterator.map(({ babel }) => {
            return {
                success: Boolean(babel),
            };
        });
    },
};
