"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NextTemplate = void 0;
const babel = __importStar(require("@babel/core"));
const findPackageJson_1 = require("../../../findPackageJson");
const utils_1 = require("../../../utils");
const versions_1 = require("../../versions");
exports.NextTemplate = {
    message: 'It looks like you are using next.js.',
    getExampleUrl: () => {
        return 'https://github.com/cypress-io/cypress/tree/develop/npm/react/examples/nextjs';
    },
    recommendedComponentFolder: 'cypress/component',
    dependencies: ['@cypress/webpack-dev-server'],
    getPluginsCodeAst: () => {
        return {
            requiresReturnConfig: true,
            RequireAst: babel.template.ast('const injectDevServer = require(\'@cypress/react/plugins/next\')'),
            IfComponentTestingPluginsAst: babel.template.ast([
                'injectDevServer(on, config)',
            ].join('\n'), { preserveComments: true }),
        };
    },
    test: (cwd) => {
        const packageJsonIterator = findPackageJson_1.createFindPackageJsonIterator(cwd);
        return packageJsonIterator.map(({ dependencies, devDependencies }, path) => {
            if (!dependencies && !devDependencies) {
                return { success: false };
            }
            const allDeps = {
                ...(devDependencies || {}),
                ...(dependencies || {}),
            };
            const nextVersion = allDeps['next'];
            if (!nextVersion) {
                return { success: false };
            }
            if (!utils_1.validateSemverVersion(nextVersion, versions_1.MIN_SUPPORTED_VERSION['next'], 'next.js')) {
                return { success: false };
            }
            return { success: true };
        });
    },
};
