"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactScriptsTemplate = void 0;
const chalk_1 = __importDefault(require("chalk"));
const findPackageJson_1 = require("../../../findPackageJson");
const utils_1 = require("../../../utils");
const versions_1 = require("../../versions");
const babel = __importStar(require("@babel/core"));
exports.ReactScriptsTemplate = {
    recommendedComponentFolder: 'src',
    message: 'It looks like you are using create-react-app.',
    dependencies: ['@cypress/webpack-dev-server'],
    getExampleUrl: ({ componentFolder }) => {
        return componentFolder === 'src'
            ? 'https://github.com/cypress-io/cypress/tree/develop/npm/react/examples/react-scripts'
            : 'https://github.com/cypress-io/cypress/tree/develop/npm/react/examples/react-scripts-folder';
    },
    getPluginsCodeAst: () => {
        return {
            requiresReturnConfig: true,
            RequireAst: babel.template.ast('const injectDevServer = require(\'@cypress/react/plugins/react-scripts\')'),
            IfComponentTestingPluginsAst: babel.template.ast([
                'injectDevServer(on, config)',
            ].join('\n'), { preserveComments: true }),
        };
    },
    test: () => {
        // TODO also determine ejected create react app
        const packageJsonIterator = findPackageJson_1.createFindPackageJsonIterator(process.cwd());
        return packageJsonIterator.map(({ dependencies, devDependencies }) => {
            if (dependencies || devDependencies) {
                const allDeps = { ...devDependencies, ...dependencies } || {};
                if (!allDeps['react-scripts']) {
                    return { success: false };
                }
                if (!utils_1.validateSemverVersion(allDeps['react-scripts'], versions_1.MIN_SUPPORTED_VERSION['react-scripts'])) {
                    console.warn(`It looks like you are using ${chalk_1.default.green('create-react-app')}, but we support only projects with version ${chalk_1.default.bold(versions_1.MIN_SUPPORTED_VERSION['react-scripts'])} of react-scripts.`);
                    // yey found the template
                    return { success: false };
                }
                return { success: true };
            }
            return { success: false };
        });
    },
};
