"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WebpackTemplate = void 0;
const babel = __importStar(require("@babel/core"));
const path_1 = __importDefault(require("path"));
const templateUtils_1 = require("../templateUtils");
exports.WebpackTemplate = {
    message: 'It looks like you have custom `webpack.config.js`. We can use it to bundle the components for testing.',
    getExampleUrl: () => {
        return 'https://github.com/cypress-io/cypress/tree/develop/npm/react/examples/webpack-file';
    },
    recommendedComponentFolder: 'cypress/component',
    dependencies: ['@cypress/webpack-dev-server'],
    getPluginsCodeAst: (payload, { cypressProjectRoot }) => {
        const includeWarnComment = !payload;
        const webpackConfigPath = payload
            ? path_1.default.relative(cypressProjectRoot, payload.webpackConfigPath)
            : './webpack.config.js';
        return {
            requiresReturnConfig: true,
            RequireAst: babel.template.ast('const injectDevServer = require("@cypress/react/plugins/load-webpack")'),
            IfComponentTestingPluginsAst: babel.template.ast([
                'injectDevServer(on, config, {',
                includeWarnComment
                    ? '  // TODO replace with valid webpack config path'
                    : '',
                `  webpackFilename: '${webpackConfigPath}'`,
                '})',
            ].join('\n'), { preserveComments: true }),
        };
    },
    test: (root) => {
        const webpackConfigPath = templateUtils_1.findWebpackConfig(root);
        return webpackConfigPath ? {
            success: true,
            payload: { webpackConfigPath },
        } : {
            success: false,
        };
    },
};
