"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VueCliTemplate = void 0;
const babel = __importStar(require("@babel/core"));
const findPackageJson_1 = require("../../../findPackageJson");
exports.VueCliTemplate = {
    message: 'It looks like you are using vue-cli-service to run and build an application.',
    getExampleUrl: () => 'https://github.com/cypress-io/cypress/tree/develop/npm/vue/examples/cli',
    recommendedComponentFolder: 'src',
    dependencies: ['@cypress/webpack-dev-server'],
    getPluginsCodeAst: () => {
        return {
            requiresReturnConfig: true,
            RequireAst: babel.template.ast([
                'const { startDevServer } = require("@cypress/webpack-dev-server")',
                `const webpackConfig = require("@vue/cli-service/webpack.config.js")`,
            ].join('\n')),
            IfComponentTestingPluginsAst: babel.template.ast([
                `on('dev-server:start', (options) => startDevServer({ options, webpackConfig }))`,
            ].join('\n'), { preserveComments: true }),
        };
    },
    test: (root) => {
        const hasVueCliService = findPackageJson_1.scanFSForAvailableDependency(root, { '@vue/cli-service': '>=4' });
        return {
            success: hasVueCliService,
        };
    },
};
