declare type PackageJsonLike = {
    name?: string;
    scripts?: Record<string, string>;
    dependencies?: Record<string, string>;
    devDependencies?: Record<string, string>;
    [key: string]: unknown;
};
/**
 * Return the parsed package.json that we find in a parent folder.
 *
 * @returns {Object} Value, filename and indication if the iteration is done.
 */
export declare function createFindPackageJsonIterator(rootPath?: string): {
    map: <TPayload>(cb: (data: PackageJsonLike, packageJsonPath: string) => {
        success: boolean;
        payload?: TPayload | undefined;
    }) => {
        success: boolean;
        payload?: undefined;
    } | {
        success: boolean;
        payload: TPayload | undefined;
    };
};
export declare function scanFSForAvailableDependency(cwd: string, lookingForDeps: Record<string, string>): boolean;
export declare type PackageJsonIterator = ReturnType<typeof createFindPackageJsonIterator>;
export {};
