#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const commander_1 = require("commander");
const main_1 = require("./main");
const package_json_1 = require("../package.json");
commander_1.program
    .option('--ignore-examples', 'Ignore generating example tests and fixtures by creating one ready-to-fill spec file')
    .option('--use-npm', 'Use npm even if yarn is available')
    .option('--ignore-ts', 'Ignore typescript if available')
    .option('--component-tests', 'Run component testing installation without asking');
commander_1.program.version(package_json_1.version, '-v --version');
commander_1.program.parse(process.argv);
main_1.main({
    useNpm: commander_1.program.useNpm,
    ignoreTs: commander_1.program.ignoreTs,
    ignoreExamples: Boolean(commander_1.program.ignoreExamples),
    setupComponentTesting: commander_1.program.componentTests,
}).catch(console.error);
