"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getInitialTsConfigPath = exports.getInitialPluginsFilePath = exports.getInitialSupportFilesPaths = void 0;
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const INITIAL_TEMPLATE_PATH = path_1.default.resolve(__dirname, '..', 'initial-template');
async function getInitialSupportFilesPaths() {
    return (await fs_extra_1.default.readdir(path_1.default.join(INITIAL_TEMPLATE_PATH, 'support'))).map((filename) => path_1.default.join(INITIAL_TEMPLATE_PATH, 'support', filename));
}
exports.getInitialSupportFilesPaths = getInitialSupportFilesPaths;
function getInitialPluginsFilePath() {
    return path_1.default.join(INITIAL_TEMPLATE_PATH, 'plugins', 'index.js');
}
exports.getInitialPluginsFilePath = getInitialPluginsFilePath;
function getInitialTsConfigPath() {
    return path_1.default.join(INITIAL_TEMPLATE_PATH, 'tsconfig.json');
}
exports.getInitialTsConfigPath = getInitialTsConfigPath;
